unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Menus, IniFiles, ExtCtrls, ComCtrls, iDragDrop;

type
  TForm1 = class(TForm)
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuPath: TMenuItem;
    MenuSays: TMenuItem;
    MenuLicense: TMenuItem;
    MenuVersion: TMenuItem;
    MenuOpt: TMenuItem;
    MenuBackup: TMenuItem;
    MenuExport: TMenuItem;
    MenuIcon: TMenuItem;
    MenuMisc: TMenuItem;
    MenuAbout: TMenuItem;
    TrkLevel: TTrackBar;
    LblLevel: TLabel;
    Label2: TLabel;
    PnlComp: TPanel;
    PnlDeComp: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrkLevelChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MenuPathClick(Sender: TObject);
    procedure MenuSaysClick(Sender: TObject);
    procedure MenuLicenseClick(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
  private
    FIniName    : string;
    FIniFile    : TIniFile;
    Dropper     : TShellDrop;
    FLock       : Boolean;

    FStdOut, FErrOut: TStringList;
    procedure   ClearOut();
    procedure   ShowOut();

    procedure   DroppedAction(AFiles, NotUse01: TStringList;
                            AControl: TControl; NotUse02: TPoint);
//    procedure   DroppedAction(AFiles, AFolds: TStringList;
//                            AControl: TControl; APos: TPoint);
    procedure   DoLevelCompress(const Path: string);
    procedure   DoBestCompress(const Path: string);
    procedure   DoDeCompress(const Path: string);

    function    UpxPathStr(): string;
    function    UpxOptStr(): string;
    function    UpxLevelStr(): string;

    procedure   SetEnable();
    procedure   ExecuteWithShow(const Line: string);

    procedure   LoadSetting();
    procedure   SaveSetting();
  public

  end;

var
  Form1: TForm1;

implementation

uses
    GrabConsole, fjutil, Info;

{$R *.dfm}

//------------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  ^Cgݒ
    FBox.SetCaption(Self);
    //  INIt@Č
    FIniName := ChangeFileExt(ParamStr(0), '.ini');
    //  ۑǍ
    LoadSetting();
    TrkLevelChange(TrkLevel);
    //  bN
    FLock := false;
    //  R\[pCvpXg쐬
    FStdOut := TStringList.Create;
    FErrOut := TStringList.Create;
    //  VFhbvpNX쐬
    Dropper := TShellDrop.Create(Self, DroppedAction);
    //  UPXpX`FbN
    SetEnable();
end;

//------------------------------------------------------------------------------
//  fXgN^
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  VFhbvpNXj
    Dropper.Free;
    //  R\[pCvpXgj
    FStdOut.Free;
    FErrOut.Free;
    //  ۑ
    SaveSetting();
end;

//------------------------------------------------------------------------------
//  I
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    //  bNĂ܂?
    CanClose := not FLock;
end;

//------------------------------------------------------------------------------
//  R\[pCvpXgNA
procedure   TForm1.ClearOut();
begin
    FStdOut.Clear;
    FErrOut.Clear;
end;

//------------------------------------------------------------------------------
//  R\[pCvpXge\
procedure   TForm1.ShowOut();
begin
    //  G[
    if FErrOut.Count > 0 then
        //  ꂾ\
        MBox.ErrorOk(FErrOut.Text, true)
    //  łȂ
    else
        //  Wo͂̂ݕ\
        MBox.InfoOk(FStdOut.Text, true);
end;

//------------------------------------------------------------------------------
//  t@Chbv
//procedure   TForm1.DroppedAction(AFiles, AFolds: TStringList;
//            AControl: TControl; APos: TPoint);
procedure   TForm1.DroppedAction(AFiles, NotUse01: TStringList;
                            AControl: TControl; NotUse02: TPoint);
var
    i: integer;
begin
    //  hbvʒu`FbN
    if ((AControl <> PnlComp) and (AControl <> PnlDeComp)) then
    begin
        MBox.InfoOk('Ⴂ܂B', true);
        exit;
    end;

    //  VFhbvt~
    Dropper.Stop();
    //  J[\ύX
    Screen.Cursor := crHourGlass;
    //  pCvւXgNA
    ClearOut();

    //  ƂꂽSẴt@Cɂ  
    for i := 0 to AFiles.Count - 1 do
    begin
        //  gq`FbNđΏۈȊOȂXLbv
        if (AnsiPos(UpperCase(ExtractFileExt(AFiles[i])), '.EXE,.DLL') = 0) then continue;
        //  bN
        FLock := true;
        //  kꏊȂ
        if (AControl = PnlComp) then
        begin
            //  xāAubestvkǂ
            if (TrkLevel.Position = 10) then DoBestCompress(AFiles[i])
                                        else DoLevelCompress(AFiles[i]);
        end
        //  𓀏ꏊȂ
        else
        if (AControl = PnlDeComp) then
        begin
            //  
            DoDeCompress(AFiles[i]);
        end;
        //  bN
        FLock := false;

        //  ESC Œf
        if WinApi.IsKeyDown(VK_ESCAPE) then break;
    end;

    //  J[\߂
    Screen.Cursor := crDefault;
    //  \
    ShowOut();
    //  VFhbvtĊJ
    Dropper.Start();
end;


//------------------------------------------------------------------------------
//  Ǎ
procedure   TForm1.LoadSetting();
begin
    //  ININX쐬
    FIniFile := TIniFile.Create(FIniName);
    try
        //  tH[̈ʒu
        Self.Left := FIniFile.ReadInteger(Self.Name, 'Left', Self.Left);
        Self.Top  := FIniFile.ReadInteger(Self.Name, 'Top', Self.Top);
        //  UPX̃pX
        MenuPath.Caption := FIniFile.ReadString(MenuPath.Name, 'Caption', MenuPath.Caption);
        //  UPX̃IvVݒ
        MenuBackup.Checked := FIniFile.ReadBool(MenuBackup.Name, 'Checked', MenuBackup.Checked);
        MenuExport.Checked := FIniFile.ReadBool(MenuExport.Name, 'Checked', MenuExport.Checked);
        MenuIcon.Checked   := FIniFile.ReadBool(MenuIcon.Name,   'Checked', MenuIcon.Checked);
    finally
        //  ININXj
        FIniFile.Free;
    end;
end;

//------------------------------------------------------------------------------
//  ۑ
procedure   TForm1.SaveSetting();
begin
    //  ININX쐬
    FIniFile := TIniFile.Create(FIniName);
    try
        //  tH[̈ʒu
        FIniFile.WriteInteger(Self.Name, 'Left', Self.Left);
        FIniFile.WriteInteger(Self.Name, 'Top', Self.Top);
        //  UPX̃pX
        FIniFile.WriteString(MenuPath.Name, 'Caption', MenuPath.Caption);
        //  UPX̃IvVݒ
        FIniFile.WriteBool(MenuBackup.Name, 'Checked', MenuBackup.Checked);
        FIniFile.WriteBool(MenuExport.Name, 'Checked', MenuExport.Checked);
        FIniFile.WriteBool(MenuIcon.Name,   'Checked', MenuIcon.Checked);
    finally
        //  ININXj
        FIniFile.Free;
    end;
end;

//------------------------------------------------------------------------------
//  Aboutʕ\
procedure TForm1.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//------------------------------------------------------------------------------
//  ݒ肵ĂUpx̃pX擾
function    TForm1.UpxPathStr(): string;
begin
    //  j[̃LvV𗘗pĂ̂Łu&(ANZ[^L[/t)v
    //  ĕԂ
    Result := StripHotKey(MenuPath.Caption);
end;

//------------------------------------------------------------------------------
//  kIvV
const
    BACK_CMD : array[Boolean] of string = ('', ' -k');
    EXPO_CMD : array[Boolean] of string = ('', ' --compress-exports=0') ;
    ICON_CMD : array[Boolean] of string = ('', ' --compress-icons=0');

//------------------------------------------------------------------------------
//  UpẍkIvV擾
function    TForm1.UpxOptStr(): string;
begin
    Result := Format('%s%s%s', [
                        BACK_CMD[MenuBackup.Checked],
                        EXPO_CMD[MenuExport.Checked],
                        ICON_CMD[MenuIcon.Checked]
    ]);
end;

//------------------------------------------------------------------------------
//  kx
const
    LEVEL_CMD: array[0..9] of string = ('', '-1', '-2', '-3', '-4', '-5', '-6', '-7', '-8', '-9');

//------------------------------------------------------------------------------
//  Upẍkx擾
function    TForm1.UpxLevelStr(): string;
var
    Level: integer;
begin
    Level := TrkLevel.Position;
    if (Low(LEVEL_CMD) <= Level) and (Level <= High(LEVEL_CMD)) then
        Result := LEVEL_CMD[Level]
    else
        Result := '';
end;



//------------------------------------------------------------------------------
//  Upx̃pXĖ{H
procedure   TForm1.SetEnable();
var
    IsOK: Boolean;
begin
    //  t@C݂邩ǂOKǂ
    IsOK := FileExists(ExpandFileName(UpxPathStr()));
    //  UPXgp̃j[̑ی
    MenuSays.Enabled    := IsOK;
    MenuLicense.Enabled := IsOK;
    MenuVersion.Enabled := IsOK;
    //  VFhbv󂯓邩ǂ
    if (IsOK) then Dropper.Start() else Dropper.Stop();
end;

//------------------------------------------------------------------------------
//  sƂʂƂ
procedure   TForm1.ExecuteWithShow(const Line: string);
begin
    //  NA
    ClearOut();
    //  sāE󂯂Ƃ
    PipeConsole(Line, FStdOut, FErrOut);
    //  \
    ShowOut();
end;

//------------------------------------------------------------------------------
//  pXݒ
procedure TForm1.MenuPathClick(Sender: TObject);
var
    S, D: string;
begin
    //  fBNgI_CAO\
    if PShell.SelectDirectoryEx(Self, 'where is upx?', ExtractFilePath(ParamStr(0)), D) then
    begin
        //  ׂUPXEXEāA΃pXɂċL^
        S := '.\' + ExtractRelativePath(ParamStr(0), D + '\upx.exe');
        TMenuItem(Sender).Caption := S;
    end;
    //  `FbN
    SetEnable();
end;

//------------------------------------------------------------------------------
//  wv
procedure TForm1.MenuSaysClick(Sender: TObject);
begin
    ExecuteWithShow(Format('"%s"', [UpxPathStr()]));
end;

//------------------------------------------------------------------------------
//  LICENSE
procedure TForm1.MenuLicenseClick(Sender: TObject);
begin
    ExecuteWithShow(Format('"%s" -L', [UpxPathStr()]));
end;

//------------------------------------------------------------------------------
//  VERSION
procedure TForm1.MenuVersionClick(Sender: TObject);
begin
    ExecuteWithShow(Format('"%s" -V', [UpxPathStr()]));
end;

//------------------------------------------------------------------------------
//  kxύX
procedure TForm1.TrkLevelChange(Sender: TObject);
const
    LEVEL_STR: array[0..10] of string
    = ('default',
       '1 more quick', '2 more quick', '3 more quick',
       '4 middle'    , '5 middle'    , '6 middle'    ,
       '7 more small', '8 more small', '9 more small',
       'best'
    );
begin
    LblLevel.Caption := LEVEL_STR[TrkLevel.Position];
end;

//------------------------------------------------------------------------------
//  xw舳ks
procedure   TForm1.DoLevelCompress(const Path: string);
const
    COMMAND_FMT: string = '"%s" --no-color %s %s "%s"';
var
    Level: integer;
    Line: string;
begin
    Level := TrkLevel.Position;
    //  xw舳k
    if (-1 < Level) and (Level < 10) then
    begin
        Line := Format(COMMAND_FMT, [
                            UpxPathStr(),
                            UpxLevelStr(),
                            UpxOptStr(),
                            Path
        ]);
        PipeConsole(Line, FStdOut, FErrOut);
    end
end;

//------------------------------------------------------------------------------
//  xXgks
procedure   TForm1.DoBestCompress(const Path: string);
const
    TEST_CMD : array[0..1] of string = (
        '"%s" --best --crp-ms=999999 --nrv2b -o "%s" "%s"',
        '"%s" --best --crp-ms=999999 --nrv2d -o "%s" "%s"');
    BEST_CMD : array[0..1] of string = (
        '"%s" --best --crp-ms=999999 --nrv2b %s "%s"',
        '"%s" --best --crp-ms=999999 --nrv2d %s "%s"');
var
    Dir, ResB, ResD: string;
    SizeB, SizeD: integer;
    Line: string;
begin
    //  kst@C̃pX擾
    Dir := ExtractFilePath(Path);
    //  j[NȖ̎擾
    ResB := WinApi.GetTempFile(Dir, '.exe');
    ResD := WinApi.GetTempFile(Dir, '.exe');
    //  ꎞt@C폜
    DeleteFile(ResB);
    DeleteFile(ResD);

    //  eXgk 1
    Line := Format(TEST_CMD[0], [
                        UpxPathStr(),
                        ResB,
                        Path
    ]);
    PipeConsole(Line, FStdOut, FErrOut);
    //  eXgk 2
    Line := Format(TEST_CMD[1], [
                        UpxPathStr(),
                        ResD,
                        Path
    ]);
    PipeConsole(Line, FStdOut, FErrOut);

    //  G[ΏI
    if (FErrOut.Count > 0) then exit;

    //  TCY擾
    SizeB := WinApi.FileSize(ResB);
    SizeD := WinApi.FileSize(ResD);
    //  eXgpꎞt@C폜
    DeleteFile(ResB);
    DeleteFile(ResD);

    //  Ȃ̗p
    if (SizeB <= SizeD) then Line := BEST_CMD[0] else Line := BEST_CMD[1];

    //  s        
    Line := Format(Line, [UpxPathStr(), UpxOptStr(), Path]);
    PipeConsole(Line, FStdOut, FErrOut);
end;

//------------------------------------------------------------------------------
//  𓀎s
procedure   TForm1.DoDeCompress(const Path: string);
var
    Line: string;
begin
    Line := Format('"%s"-d --no-color "%s"', [UpxPathStr(), Path]);
    PipeConsole(Line, FStdOut, FErrOut);
end;

end.

